package ru.myitschool.work.ui.employee;

import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;

import ru.myitschool.work.data.dto.Employee;
import ru.myitschool.work.data.repository.InfoRepositoryImpl;
import ru.myitschool.work.domain.info.InfoUseCase;

public class EmployeeViewModel extends ViewModel {
    private final MutableLiveData<Boolean> mutableIsSuccessfulReceiptLiveData = new MutableLiveData<>();
    public final LiveData<Boolean> isSuccessfulReceiptLiveData = mutableIsSuccessfulReceiptLiveData;

    private final MutableLiveData<Employee> mutableEmployeeLiveData = new MutableLiveData<>();
    public final LiveData<Employee> employeeLiveData = mutableEmployeeLiveData;

    private final InfoUseCase infoUseCase = new InfoUseCase(InfoRepositoryImpl.getInstance());

    public void startQuery(String currentLogin) {
        infoUseCase.execute(currentLogin, status -> {
            if (status.getStatusCode() == 200) {
                mutableEmployeeLiveData.postValue(status.getValue());
                mutableIsSuccessfulReceiptLiveData.setValue(true);
            } else /*(status.getStatusCode() == 401) */ {
                mutableIsSuccessfulReceiptLiveData.setValue(false);
            }
        });
    }
}